local inc = function(prop, val)
	return function(potion, kind)
		local meta = potion:get_meta()
		meta:set_int(prop, meta:get_int(prop) + (val or 1))
	end
end

return {
	Force = {
		color = {255,165,85}; qual = 'force';
		apply = inc('force');
		describe = function(potion)
			return 'good', 'empowered', "The strength of this potion's effect has been alchemically amplified"
		end;
		infusion = 'sorcery:grease_thunder';
	};
	Longevity = {
		color = {255,85,216}; qual = 'duration';
		apply = inc('duration');
		describe = function(potion)
			return 'good', 'prolonged', 'The effects of this potion will last longer than normal'
		end;
		infusion = 'sorcery:grease_pine';
	};
	Rapidity = {
		color = {183,28,238}; qual = 'speed';
		apply = inc('speed');
		describe = function(potion)
			return 'good', 'quickened', 'This potion will take effect more quickly and easily'
		end;
		infusion = 'sorcery:liquid_sap_acacia_bottle';
	};
	Purity = {
		color = {244,255,255}; qual = 'purity';
		apply = inc('purity');
		describe = function(potion)
			return 'good', 'purified', 'This potion\'s impurities and undesirable qualities are diminished or eliminated'
		end;
		infusion = 'sorcery:oil_purifying';
	};
	Beauty = {
		color = {255,20,226}; qual = 'beauty';
		apply = inc('beauty');
		describe = function(potion)
			return 'good', 'beautified', 'The effects of this potion will be more vivid and spectacular than normal'
		end;
		infusion = 'sorcery:liquid_sap_apple_bottle';
	};
	-- Glory?
	-- Clarity?
}
