local L = sorcery.lib
return {
	magic = {
		name = "Sulavri Tefrusir" --[[
			Sulavri the Blind is the husband of Irix Irimentari. Elerian legend tells that he fell in love with Irix when she invented alchemy, and they wed, giving birth to the human race. Sulavri is Lord of the Leylines, Father of Man and Magic, and his domain is that of sorcery, physics, the aether, and all the hidden arts besides.

			legend tells that a foolish mortal king once conspired to steal away Sulavri's staff, knowing it to be the apex of the sorcerer's art and desirous of its might. wise Sulavri however saw the warnings on the wind and in the dances of the birds, and so on the fateful day he fashioned an imitation staff that held no power at all, his wife concealing his true staff by turning into a shawl and casting it about her shoulders. sure enough, when Sulavri laid down to rest at his favored mountain stream, a master thief in the employ of the king stole away the false staff, bringing it to his master. at first delighted, the king found the staff would not answer his will, and soon went mad seeking to unlock the secrets of its power.

			Sulavri is the patron of elders, men, and Wand-Working.
		]];
		laziness = 7;
		generosity = 4;
		stinginess = 1;
		freq = 1.2;
		color = {255,34,123};
		idol = {
			desc = 'Mystic Idol';
			width = 0.7;
			height = 1;
			tex = {
				"default_obsidian.png";
				"default_gold_block.png";
				"default_copper_block.png";
				"default_tin_block.png^[brighten";
				"default_bronze_block.png";
			};
			craft = {
				{'default:bronze_ingot','default:gold_ingot','default:obsidian_shard'};
				{'sorcery:fragment_copper','sorcery:silver_ingot','sorcery:fragment_copper'};
				{'default:obsidian_shard','stairs:slab_goldblock','default:bronze_ingot'};
			};
		};
		bless = {
			potions = {};
			tools = {};
		};
		gifts = {
			['sorcery:screw_steel'] = {7,1};
			['sorcery:pipe'] = {16,2};
			['sorcery:valve'] = {18,3};
			['sorcery:fragment_vidrium'] = {20,4};
			['sorcery:fragment_lithium'] = {23,5};
			['sorcery:screw_platinum'] = {31,5};
			['sorcery:screw_tungsten'] = {33,5};
			['sorcery:powder_firestorm'] = {48,7};
		};
		consecrate = {
			["sorcery:dagger"] = {17, "sorcery:dagger_consecrated"};
			["sorcery:oil_mystic"] = {9, "sorcery:oil_purifying"};
			["sorcery:potion_water"] = {4, "sorcery:holy_water"};
			["default:paper"] = function(ctx)
				local stack = ItemStack('sorcery:recipe')
				local mode = select(2,L.tbl.pick{'cook','craft','grind','enchant'})
				sorcery.cookbook.setrecipe(stack, mode, nil, {
					pred = function(c)
						local me = ctx.god
						local g = function(n)
							return minetest.get_item_group(c.item, n) ~= 0
						end
						if (mode == 'enchant' or
							(ctx.favor > 35 and (g 'sorcery_magical'
											or g 'sorcery_magitech'
											or g 'sorcery_ley_device'))
							or g 'sorcery_tech'
							or g 'crafttool'
							or me.sacrifice [c.item]
							or me.consecrate[c.item])
							and mod ~= 'farming'
								then return true end
					end;
				})
				return 3, stack
			end;
			-- ["default:gold_ingot"] = {15, "sorcery:holy_token_magic"};
		};
		sacrifice = {
			['sorcery:essence_frost'] = 15;
			['sorcery:essence_flame'] = 15;
			['sorcery:essence_force'] = 20;

			['sorcery:gem_luxite'] = 4;
			['sorcery:gem_ruby'] = 7;
			['sorcery:gem_amethyst'] = 9;
			['sorcery:gem_sapphire'] = 12;
			['sorcery:gem_emerald'] = 14;
			['default:mese_crystal'] = 18;
			['default:diamond'] = 25;

			['sorcery:gem_luxite_amulet'] = 8;
			['sorcery:gem_ruby_amulet'] = 14;
			['sorcery:gem_amethyst_amulet'] = 18;
			['sorcery:gem_sapphire_amulet'] = 23;
			['sorcery:gem_emerald_amulet'] = 14;
			['sorcery:gem_mese_amulet'] = 36;
			['sorcery:gem_diamond_amulet'] = 50;

			['sorcery:oil_mystic'] = 2;
			['sorcery:oil_berry'] = 3;
			['sorcery:oil_wind'] = 4;
			['sorcery:oil_bleak'] = 4;
			['sorcery:oil_stone'] = 5;
			['sorcery:oil_mushroom'] = 6;
			['sorcery:oil_flame'] = 7;
			['sorcery:oil_dawn'] = 8;
			['sorcery:oil_luscious'] = 9;
			['sorcery:oil_luck'] = 11;
			['sorcery:oil_sagnuine'] = -15;

			['sorcery:grease_fog'] = 15;
			['sorcery:grease_pine'] = 16;
			['sorcery:grease_storm'] = 18;
			['sorcery:grease_whisper'] = 19;
			['sorcery:grease_thunder'] = 20;
			['sorcery:grease_enchanting'] = 22;
			['sorcery:grease_lift'] = 28;
			['sorcery:grease_war'] = -5;

			['sorcery:warding_plate'] = 5;
			['sorcery:ley_puncture'] = 8;
			['sorcery:pulse_rectifier'] = 8;
			['sorcery:current_felicitator'] = 12;
			['sorcery:infuser_concentrator'] = 7;
			['sorcery:infuser_tube'] = 9;
			['sorcery:inverter_coil'] = 10;
			['sorcery:inversion_matrix'] = 22;
			['sorcery:inferno_crystal'] = 24;
			['sorcery:beam_generator'] = 27;
			['sorcery:field_emitter'] = 30;
			['sorcery:catalytic_converter'] = 30;
			['sorcery:gravity_manipulator'] = 50;

			['sorcery:core_syncretic'] = 25;
			['sorcery:core_mandatic'] = 27;
			['sorcery:core_praxic'] = 29;
			['sorcery:core_counterpraxic'] = 17;

			['sorcery:sap'] = 1;
			['sorcery:sap_apple'] = 2;
			['sorcery:sap_aspen'] = 3;
			['sorcery:sap_pine'] = 3;
			['sorcery:sap_jungle'] = 4;
			['sorcery:sap_acacia'] = 5;
			['sorcery:blood'] = -5;
		};
	};
	harvest = {
		name = "Irix Irimentari" --[[
			an old Elerian harvest goddess, Irix the Bountiful has watched vigilantly over the fields of her worshippers since before the Second Age. she favors alcoholic beverages as tribute, and has been known to perform blessings for sorcerers when sufficiently inebriated. she harbors a particular hatred of daemons and those who spill the blood of farmers.

			legend says that a barbarian lord high on opium once wandered into a temple of Irix and left the severed head of a local shepherd on the her altar. this desecration so enraged the goddess that the barbarian's entire tribe soon starved horribly to death, their crops refusing to take root, and their stolen breads turning to ash in their mouths.

			Irix is the patron of maidens, mothers, and Alchemy. it is said that Irix Irimentari herself invented alchemy when she brewed the first mead.
		]];
		laziness = 5;
		stinginess = 3;
		generosity = 10;
		freq = 1;
		color = {214, 255, 146};
		idol = {
			desc = "Harvest Idol";
			width = 0.7;
			height = 1;
			tex = {
				"default_grass.png",
				"default_gold_block.png",
				"default_copper_block.png",
				"default_tin_block.png"
			};
			craft = {
				{'sorcery:fragment_tin','default:fern_1','sorcery:fragment_tin'};
				{'sorcery:fragment_copper','default:gold_ingot','sorcery:fragment_copper'};
				{'','stairs:slab_goldblock',''};
			};
		};
		bless = {
			potions = {};
			tools = {};
		};
		consecrate = {
			["flowerpot:empty"] = {2, {
				"flowerpot:flowers_rose";
				"flowerpot:flowers_tulip";
				"flowerpot:flowers_viola";
				"flowerpot:flowers_geranium";
				"flowerpot:flowers_chrysanthemum_green";
				"flowerpot:flowers_dandelion_white";
				"flowerpot:flowers_dandelion_yellow";
			}};
			["sorcery:dagger"] = {17, "sorcery:dagger_consecrated"};
			["sorcery:oil_mystic"] = {9, "sorcery:oil_purifying"};
			["sorcery:potion_water"] = {4, "sorcery:holy_water"};
			["default:paper"] = function(ctx)
				local stack = ItemStack('sorcery:recipe')
				local mode = select(2,L.tbl.pick{'cook','craft','infuse','grind'})
				sorcery.cookbook.setrecipe(stack, mode, nil, {
					pred = function(c)
						local me = ctx.god
						if c.mod == 'farming' or
							minetest.get_item_group(c.item, 'sorcery_potion') ~= 0 or
							minetest.get_item_group(c.item, 'sorcery_oil') ~= 0 or
							minetest.get_item_group(c.item, 'sorcery_grease') ~= 0 or
							minetest.get_item_group(c.item, 'sorcery_extract') ~= 0 or
							minetest.get_item_group(c.item, 'sorcery_container') ~= 0 or
							minetest.get_item_group(c.item, 'plant') ~= 0 or
							minetest.get_item_group(c.item, 'flora') ~= 0 or
							minetest.get_item_group(c.item, 'flowerpot') ~= 0 or
							me.sacrifice [c.item] or
							me.consecrate[c.item]
								then return true end
					end;
				})
				return 1, stack
			end;
			-- ["default:steel_ingot"] = {15, "sorcery:holy_token_harvest"};
		};
		sacrifice = {
			-- beattitudes
			["farming:straw"           ] = 1;
			["farming:bread_slice"     ] = 1;
			["farming:bread"           ] = 2;
			["farming:cookie"          ] = 2;
			["farming:rice_bread"      ] = 2;
			["farming:donut"           ] = 2;
			["farming:donut_apple"     ] = 3;
			["farming:apple_pie"       ] = 3;
			["farming:rhubarb_pie"     ] = 4;
			["farming:muffin_blueberry"] = 4;
			["farming:garlic_bread"    ] = 4;
			["farming:bread_multigrain"] = 5;
			["farming:pumpkin_bread"   ] = 5;
			["farming:donut_chocolate" ] = 5;
			["farming:porridge"        ] = 5;
			["farming:turkish_delight" ] = 6;
			["farming:jaffa_cake"      ] = 7;

			["wine:glass_wheat_beer"] = 2;
			["wine:glass_beer"      ] = 2;
			["wine:glass_rum"       ] = 2;
			["wine:glass_wine"      ] = 3;
			["wine:glass_cider"     ] = 3;
			["wine:glass_sake"      ] = 3;
			["wine:glass_bourbon"   ] = 4;
			["wine:glass_vodka"     ] = 4;
			["wine:glass_mint"      ] = 5;
			["wine:glass_mead"      ] = 6;
			["wine:glass_tequila"   ] = 7;

			["wine:bottle_wheat_beer"] = 6;
			["wine:bottle_beer"      ] = 6;
			["wine:bottle_rum"       ] = 7;
			["wine:bottle_wine"      ] = 8;
			["wine:bottle_cider"     ] = 8;
			["wine:bottle_sake"      ] = 5;
			["wine:bottle_bourbon"   ] = 5;
			["wine:bottle_vodka"     ] = 8;
			["wine:bottle_mint"      ] = 9;
			["wine:bottle_mead"      ] = 12;
			["wine:bottle_tequila"   ] = 20;

			-- abominations
			["default:iron_lump"] = -1;
			["default:tin_lump"] = -1;
			["default:copper_lump"] = -1;
			["default:coal_lump"] = -2;
			["default:cactus"] = -2;
			["default:dirt"] = -5;
			["moreblocks:tar"] = -9;
			["default:bucket_lava"] = -12;
			["sorcery:blood"] = -15;
			["bonemeal:bone"] = -20;
			["default:bones"] = -35;
		};
		gifts = {
			-- gift specs = {favor, chance} where chance is the likelihood of a god bestowing the gift
			["default:blueberry_bush_sapling"] = {120,15};
			["default:blueberries"] = {60, 4};
			["farming:coffee_beans"] = {58, 9};
			["farming:seed_hemp"] = {55, 8};
			["bonemeal:fertiliser"] = {53, 3};
			["farming:garlic_clove"] = {50, 7};
			["farming:seed_mint"] = {50, 7};
			["flowers:mushroom_red"] = {45, 2};
			["farming:grapes"] = {43, 6};
			["farming:seed_barley"] = {40, 6};
			["farming:rhubarb"] = {38, 8};
			["farming:beans"] = {35, 6};
			["farming:raspberries"] = {30, 5};
			["bonemeal:mulch"] = {32, 3};
			["farming:corn"] = {27, 2};
			["farming:sugar"] = {24, 4};
			["farming:salt"]  = {24, 3};
			["farming:onion"] = {20, 7};
			["farming:carrot"] = {20, 7};
			["default:apple"] = {18, 2};
			["farming:wheat"] = {14, 2};
			["bonemeal:mulch"] = {7, 7};
		};
	};

	blood = {
		name = 'Faramesti Surax';
		bless = {
			potions = {
				Force = {favor=50, cost=5, chance=7};
				Longevity = {favor=65, cost=7, chance=3};
			};
			tools = {
				rend = {favor=80, cost=15, chance=20};
			};
		};
		laziness = 2;
		generosity = 4;
		stinginess = 9;
		idol = {
			desc = "Blood Idol";
			width = 0.7;
			height = 1.3;
			tex = {
				"default_obsidian.png";
				"default_gold_block.png";
				"default_copper_block.png";
				-- "default_bronze_block.png^[multiply:#C32F2F";
				"default_bronze_block.png";
				"default_tin_block.png";
			};
		};
		sacrifice = {
			["sorcery:blood"] = 3;
			["bonemeal:bone"] = 9;
			["default:bones"] = 17;
			["sorcery:oil_sanguine"] = 26;

			-- abominations
			["default:apple"] = -10;
			["farming:wheat"] = -20;
			["farming:bread"] = -30;
		};
		gifts = {
			["tnt:gunpowder"] = {40, 2};
			["bonemeal:bonemeal"] = {25, 4};
			["sorcery:grease_war"] = {98, 6};
		};
		consecrate = {
			["sorcery:dagger"] = {4, "sorcery:dagger_consecrated"};
		};
	};
}
